//
//  ZJPopListView.m
//  TplhkSaleSupportSystemOC
//
//  Created by 张军 on 2018/11/27.
//  Copyright © 2018 张军. All rights reserved.
//

#import "ZJPopListView.h"
#import "ZJTextField.h"
#import "Masonry.h"
// RGB颜色
#define ZJColor(r, g, b) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:1.0]

@interface ZJPopListView ()<UITableViewDelegate,UITableViewDataSource>
@property(nonatomic,strong)NSMutableArray * stateSelModelArray;
@property(nonatomic,weak)ZJTextField * textField;
@end

@implementation ZJPopListView

//数据源数组 一般为字符串数组
- (instancetype)initWithDataArray:(NSArray *)dataArray supreTextField:(ZJTextField *)textField{
    if(self = [super init]){
//        self.backgroundColor = [UIColor blackColor];
//        self.alpha = 0.3;
        self.stateSelModelArray = [NSMutableArray arrayWithArray:dataArray];
        self.textField = textField;
    }
    return self;
}

- (void)popListViewShow{
    self.hidden = NO;
    self.stateSelTableView.hidden = NO;
    
    UIWindow * keyWindow = [UIApplication sharedApplication].keyWindow;
    CGRect frame = [self.textField convertRect: self.textField.bounds toView:keyWindow];
    [keyWindow addSubview:self];
    [self mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.top.equalTo(keyWindow).offset(0);
    }];
    
    [self addSubview:self.coveButton];
    [self.coveButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.top.equalTo(self).offset(0);
    }];
    
    [self addSubview:self.stateSelTableView];
    [self.stateSelTableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self).offset(frame.origin.x);
        make.top.equalTo(self).offset(frame.origin.y+frame.size.height + 5);
        make.width.offset(frame.size.width);
        make.height.offset(185);
    }];

}
- (void)popListViewHide{
    [self removeFromSuperview];
}
//弹出的遮盖层点击
- (void)coveButtonClick:(UIButton *)btn{
    [self removeFromSuperview];
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self removeFromSuperview];
    [self endEditing:YES];
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.stateSelModelArray.count;
}
//三个选择栏 每个都是一个tableView
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    static NSString * stateSelTableViewID = @"stateSelTableViewID";
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:stateSelTableViewID];
    if(cell == nil){
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:stateSelTableViewID];
    }
    cell.textLabel.text = [self.stateSelModelArray objectAtIndex:indexPath.row];
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 40;
}

//选中选项后 移除选择栏 并把选中的内容填充到view上
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    self.stateSelTableView.hidden = YES;
    [self coveButtonClick:nil];
    if([self.delegate respondsToSelector:@selector(popListView:didClickTableRowOfText:)]){
        [self.delegate popListView:self didClickTableRowOfText: [self.stateSelModelArray objectAtIndex:indexPath.row]];
    }
}

- (UIButton *)coveButton{
    if(!_coveButton){
        _coveButton = [[UIButton alloc]init];
        _coveButton.backgroundColor = [UIColor blackColor];
        _coveButton.alpha = 0.3;
        [_coveButton addTarget:self action:@selector(coveButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _coveButton;
}

- (UITableView *)stateSelTableView {
    if (!_stateSelTableView) {
        _stateSelTableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain];
        _stateSelTableView.delegate = self;
        _stateSelTableView.dataSource = self;
        _stateSelTableView.estimatedRowHeight = 0;
        _stateSelTableView.estimatedSectionHeaderHeight = 0;
        _stateSelTableView.estimatedSectionFooterHeight = 0;
        _stateSelTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        _stateSelTableView.backgroundColor = ZJColor(233, 233, 233);
        _stateSelTableView.layer.cornerRadius = 8.0;
        _stateSelTableView.layer.masksToBounds = YES;
    }
    return _stateSelTableView;
}

- (NSMutableArray *)stateSelModelArray{
    if(!_stateSelModelArray){
        _stateSelModelArray = [NSMutableArray array];
    }
    return _stateSelModelArray;
}
@end
