//
//  ZJTextField.m
//  TplhkSaleSupportSystemOC
//
//  Created by 张军 on 2018/11/27.
//  Copyright © 2018 张军. All rights reserved.
//

#import "ZJTextField.h"
#import "ZJPopListView.h"
// RGB颜色
#define ZJColor(r, g, b) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:1.0]

@interface ZJTextField () <ZJPopListViewDelegate>
@property(nonatomic,strong)UIButton * coveButton;
@end

@implementation ZJTextField
- (instancetype)initWithPlaceholder:(NSString *)placeholder{
    if(self = [super init]){
    
        self.backgroundColor = [UIColor whiteColor];
        self.placeholder = placeholder;
        self.borderStyle = UITextBorderStyleRoundedRect;
        self.font = [UIFont systemFontOfSize:16];
        self.layer.cornerRadius = 5.0;
        self.layer.masksToBounds = YES;
        self.layer.borderWidth = 1.0;
        self.layer.borderColor = ZJColor(239, 239, 239).CGColor;
        UILabel * leftView = [[UILabel alloc] initWithFrame:CGRectMake(10,0,10,26)];
        leftView.backgroundColor = [UIColor clearColor];
        self.leftView = leftView;
        self.leftViewMode = UITextFieldViewModeAlways;
        self.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        
        [self setUi];
    }
    return self;
}

- (instancetype)initWithCoder:(NSCoder *)aDecoder{
    if(self = [super initWithCoder:aDecoder]){
        
        self.backgroundColor = [UIColor whiteColor];
        self.borderStyle = UITextBorderStyleRoundedRect;
        self.font = [UIFont systemFontOfSize:16];
        self.layer.cornerRadius = 5.0;
        self.layer.masksToBounds = YES;
        self.layer.borderWidth = 1.0;
        self.layer.borderColor = ZJColor(239, 239, 239).CGColor;
        UILabel * leftView = [[UILabel alloc] initWithFrame:CGRectMake(10,0,10,26)];
        leftView.backgroundColor = [UIColor clearColor];
        self.leftView = leftView;
        self.leftViewMode = UITextFieldViewModeAlways;
        self.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        
        [self setUi];
    }
    return self;
}

- (void)popListView:(ZJPopListView *)ZJPopListView didClickTableRowOfText:(NSString *)text{
    self.text = text;
}

- (void)setDataArray:(NSArray *)dataArray{
    _dataArray = [NSMutableArray arrayWithArray:dataArray];
}

//点击弹出列表
- (void)coveButtonClick:(UIButton *)btn{
    
    if(_dataArray.count == 0){
        NSAssert(NO, @"请给本类的dataArray赋值字符串数组 才能展示具体数据");
    }
    
    for (id str in _dataArray) {
        if(![str isKindOfClass:[NSString class]]){
            NSAssert(NO, @"dataArray必须是字符串数组");
        }
    }
    
    ZJPopListView * popView = [[ZJPopListView alloc]initWithDataArray:_dataArray supreTextField:self];
    popView.delegate = self;
    [popView popListViewShow];
}

- (void)setUi{
    [self addSubview:self.coveButton];
    [self.coveButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.top.equalTo(self).offset(0);
    }];
}


- (UIButton *)coveButton{
    if(!_coveButton){
        _coveButton = [[UIButton alloc]init];
        [_coveButton addTarget:self action:@selector(coveButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _coveButton;
}
@end
